unit mystatus;

interface

{$R status.res}

uses Wintypes,Winprocs,WObjects;

const statusid='STATUS';

type
 Pstatus=^Tstatus;
 Tstatus=object(TDialog)
 continueflag:boolean;
 constructor init(AParent:PwindowsObject;Aname:Pchar);
 procedure changetitle(title:Pchar);
 procedure beginstatus(statuslabel:Pchar);
 procedure endstatus;
 procedure update;virtual;
 procedure update1(P:Pchar);
 procedure update2(P:Pchar);
 procedure update3(P:Pchar);
 procedure cancel(var msg:TMessage);
   virtual id_first + id_cancel;
 function continue:boolean;
end;

implementation

const id_label=101;
      id_status_1=102;
      id_status_2=103;
      id_status_3=104;

constructor tstatus.init(AParent:PWindowsObject;Aname:Pchar);
begin
  TDialog.init(AParent,AName);
  EnableKBHandler;
  continueflag:=true;
end;

procedure TStatus.ChangeTitle(Title:Pchar);
begin
  setwindowtext(Hwindow,title);
end;

procedure TStatus.BeginStatus(StatusLabel:Pchar);
begin
  senddlgitemmsg(id_label,wm_settext,0,longint(statuslabel));
  show(sw_shownormal);
  setfocus(hwindow);
  continueflag:=true;
end;

procedure TStatus.endstatus;
begin
  show(sw_hide);
end;

procedure TStatus.Update;
var Msg:TMsg;
begin
  while peekmessage(Msg,0,0,0,pm_remove) do
  if not isdialogmessage(hwindow,msg) then
  begin
    translatemessage(msg);
    dispatchmessage(msg);
  end
end;

procedure TStatus.Update1(P:Pchar);
begin
  update;
  senddlgitemmsg(id_status_1,wm_settext,0,longint(P));
end;

procedure TStatus.Update2(P:Pchar);
begin
  update;
  senddlgitemmsg(id_status_2,wm_settext,0,longint(p))
end;

procedure TStatus.Update3(P:Pchar);
begin
  update;
  senddlgitemmsg(id_status_3,wm_settext,0,longint(p))
end;

procedure TStatus.Cancel(var msg:Tmessage);
begin
  continueflag:=false;
end;

function TStatus.continue:boolean;
begin
  continue:=continueflag;
end;

end.
