Unit Wgraphics;
{by T. Fulton CIS:[100015,565]}
{July 1993}

Interface
uses Wintypes,Winprocs,Stdwnds,Strings;
type
 wrkstring=string[10];

procedure drawline(aDC:hdc;x1,y1,x2,y2:integer);
function StringNumber(X1 : real; MaxExponent : integer) : WrkString;
procedure DrawNum(adc:hdc;X1, Y1, MaxExponent : integer; Number : real);
procedure DrawExponent(adc:hdc;X1, Y1, MaxExponent : integer);
procedure Death(thedc:hdc);
procedure resurrection(thedc:hdc;w1,w2,w3,w4,w5,w6:word);

implementation
 procedure drawline(aDC:hdc;x1,y1,x2,y2:integer);
begin
  moveto(aDC,x1,y1);
  lineto(aDC,x2,y2);
end;

function StringNumber(X1 : real; MaxExponent : integer) : WrkString;
var
  Y : WrkString;
begin
  Str(X1 * Exp(-MaxExponent * Ln(10.0)):5:2, Y);
  StringNumber := Y;
end; { StringNumber }

procedure DrawNum(adc:hdc;X1, Y1, MaxExponent : integer; Number : real);
var
  I,charsize : integer;
  StrNumber  : array[0..9] of char;
  tempstr   : wrkstring;

begin
  tempstr := StringNumber(Number, MaxExponent);
  Y1 := Y1 - 7;
  strpcopy(strnumber,tempstr);
  textout(aDC,x1,y1,strnumber,strlen(strnumber));
end; { DrawNum }

procedure DrawExponent(adc:hdc;X1, Y1, MaxExponent : integer);
var
  I,charsize : integer;
  StrNumber  : array[0..9] of char;
  tempstr   : wrkstring;

begin
  strcopy(strnumber,'10');
  Textout(aDC,x1,y1,strnumber,strlen(strnumber));
  Str(MaxExponent:3, StrNumber);
  Y1 := Y1 - 4;
  X1 := X1 +15;
  Textout(aDC,x1,y1,strnumber,strlen(strnumber));
end; { DrawExponent }

procedure Death(thedc:hdc); External 'GDI' index 121;
procedure resurrection(thedc:hdc;w1,w2,w3,w4,w5,w6:word);
          external 'GDI' index 122;

end.